brain_two/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.urls import path
from django.views.generic.base import RedirectView

urlpatterns = [
    path('admin/', admin.site.urls),
    path("todos/", include("todos.urls")),
    path("", RedirectView.as_view(url="/todos")),
]

todos/urls.py
from django.urls import path
from todos.views import (
    TodoListCreate, 
    TodoListDelete, 
    TodoListUpdate, 
    TodoListView, 
    TodoListDetail, 
    TodoItemCreate, 
    TodoItemUpdate
)

urlpatterns = [
    path("", TodoListView.as_view(), name="todo_list"), 
    path("<int:pk>/", TodoListDetail.as_view(), name="todo_list_detail"),
    path("<int:pk>/edit/", TodoListUpdate.as_view(), name="todo_list_update"),
    path("add/", TodoListCreate.as_view(), name="todo_list_add"),
    path("<int:pk>/delete/", TodoListDelete.as_view(), name="todo_list_delete"),
    path("items/new/", TodoItemCreate.as_view(), name="todo_item_create"),
    path("items/<int:pk>/edit/", TodoItemUpdate.as_view(), name="todo_item_update"),
]

todos/models.py
from typing_extensions import Self
from django.db import models

# Create your models here.
class TodoList(models.Model):
    name = models.CharField(max_length=100)
    created_on = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.name
    

class TodoItem(models.Model):
    task = models.CharField(max_length=100)
    due_date = models.DateTimeField(null=True, blank=True)
    is_completed = models.BooleanField(default=False)
    list = models.ForeignKey(TodoList, related_name="items", on_delete=models.CASCADE)

    def __str__(self):
        return self.task
        

todos/views.py
from collections import deque
from django.shortcuts import render
from django.views.generic.edit import CreateView, DeleteView, UpdateView
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from todos.models import TodoItem, TodoList
from django.urls import include, path, reverse_lazy

# Create your views here.

class TodoListView(ListView):
    model = TodoList
    template_name = "todo_lists/list.html"


class TodoListDetail(DetailView):
    model = TodoList
    template_name = "todo_lists/detail.html"
    

class TodoListCreate(CreateView):
    model = TodoList
    template_name = "todo_lists/add.html"
    fields = ["name"]
    success_url = reverse_lazy("todo_list")

    def form_valid(self, form):
        return super().form_valid(form)
    

class TodoListUpdate(UpdateView):
    model = TodoList
    template_name = "todo_lists/edit.html"
    name = TodoList.name
    fields = ["name"]
    success_url = reverse_lazy("todo_list")
    

class TodoListDelete(DeleteView):

    model = TodoList
    template_name = "todo_lists/delete.html"
    

class TodoItemCreate(CreateView):
    model = TodoItem
    template_name = "todo_items/create.html"
    fields = ["task", "due_date", "is_completed", "list"]
    success_url = reverse_lazy("todo_list")

    def form_valid(self, form):
        return super().form_valid(form)

class TodoItemUpdate(UpdateView):
    model = TodoItem
    template_name = "todo_items/update.html"
    task = TodoItem.task
    due_date = TodoItem.due_date
    is_completed = TodoItem.is_completed
    list = TodoItem.list
    fields = ["task", "due_date", "is_completed", "list"]
    success_url = reverse_lazy("todo_list")

todos/templates/base.html
<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>My Todo List</title>
</head>

<body>
  {% block content %}
  {% endblock content %}
</body>
</html>

todos/templates/todo_items/create.html
{% extends 'base.html' %}


{% block content %}
  <main>
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Submit</button>
      </div>
    </form>
  </main>
  {% endblock content %}

todos/templates/todo_items/update.html
{% extends 'base.html' %}


{% block content %}
  <main>
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Submit</button>
      </div>
    </form>
  </main>
  {% endblock content %}

todos/templates/todo_lists/add.html
{% extends 'base.html' %}


{% block content %}
  <main>
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">Name</button>
      </div>
    </form>
  </main>
  {% endblock content %}

todos/templates/todo_lists/detail.html
{% extends 'base.html' %}

{% block content %}
  <main>
    <a href="{% url 'todo_list' %}">back</a>
    <a href="{% url 'todo_list_update' todolist.id %}">edit</a>
    <a href="{% url 'todo_list_delete' todolist.id %}">remove</a>
    <h1>{{ todolist.name }}</h1>
    <h2>Tasks</h2>
    <table>
      <thead>
        <tr>
          <th>Task</th>
          <th>Due date</th>
        </tr>
      </thead>
      <tbody>
        {% for item in todolist.items.all %}
          <tr>
            <td>
              <a href="{% url 'todo_item_update' item.id %}">
                {{ item.task }}
              </a>
            </td>
            <td>{{ item.due_date|date:"M d, Y"}}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </main>
{% endblock content %}

todos/templates/todo_lists/edit.html
{% extends 'base.html' %}


{% block content %}
  <main>
    <form method="post">
      {% csrf_token %}
      {{ form.as_p }}
      <div class="control">
        <button class="button">update name</button>
      </div>
    </form>
  </main>
  {% endblock content %}

todos/templates/todo_lists/list.html
{% extends 'base.html' %}

{% block content %}
  <main>
    <h1>My lists</h1>
    <a href="{% url 'todo_list_add' %}">New list</a>
    <a href="{% url 'todo_item_create' %}">New item</a>
    <table>
      <thead>
        <tr>
          <th>Name</th>
          <th>Number of items</th>
        </tr>
      </thead>
      <tbody>
        {% for list in todolist_list %}
          <tr>
            <td>
              <a href="{% url 'todo_list_detail' list.id %}">
                {{ list.name }}
              </a>
            </td>
            <td>{{ list.items.all|length }}</td>
          </tr>
        {% endfor %}
      </tbody>
    </table>
  </main>
{% endblock content %}